/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of duk.xs. Do not edit this file, edit duk.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "duk.xs"
#define PERL_NO_GET_CONTEXT      /* we want efficiency */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

/*
 * Duktape is an embeddable Javascript engine, with a focus on portability and
 * compact footprint.
 *
 * http://duktape.org/index.html
 */
#include "pl_duk.h"
#include "pl_stats.h"
#include "pl_module.h"
#include "pl_eventloop.h"
#include "pl_console.h"
#include "pl_native.h"
#include "pl_inlined.h"
#include "pl_sandbox.h"
#include "pl_util.h"

#define MAX_MEMORY_MINIMUM  (128 * 1024) /* 128 KB */
#define MAX_TIMEOUT_MINIMUM (500000)     /* 500_000 us = 500 ms = 0.5 s */

#define TIMEOUT_RESET(duk) \
    do { \
        if (duk->max_timeout_us > 0) { \
            duk->eval_start_us = now_us(); \
        } \
    } while (0) \

static void duk_fatal_error_handler(void* udata, const char* msg)
{
    dTHX;

    /* Duk* duk = (Duk*) udata; */
    UNUSED_ARG(udata);

    PerlIO_printf(PerlIO_stderr(), "duktape fatal error, aborting: %s\n", msg ? msg : "*NONE*");
    abort();
}

static void set_up(Duk* duk)
{
    if (duk->inited) {
        return;
    }
    duk->inited = 1;

    duk->ctx = duk_create_heap(pl_sandbox_alloc, pl_sandbox_realloc, pl_sandbox_free, duk, duk_fatal_error_handler);
    if (!duk->ctx) {
        croak("Could not create duk heap\n");
    }

    TIMEOUT_RESET(duk);

    /* register a bunch of native functions */
    pl_register_native_functions(duk);

    /* initialize module handling functions */
    pl_register_module_functions(duk);

    /* register event loop dispatcher */
    pl_register_eventloop(duk);

    /* inline a bunch of JS functions */
    pl_register_inlined_functions(duk);

    /* initialize console object */
    pl_console_init(duk);
}

static void tear_down(Duk* duk)
{
    if (!duk->inited) {
        return;
    }
    duk->inited = 0;

    duk_destroy_heap(duk->ctx);
}

static Duk* create_duktape_object(pTHX_ HV* opt)
{
    Duk* duk = (Duk*) malloc(sizeof(Duk));
    memset(duk, 0, sizeof(Duk));

    duk->pagesize_bytes = getpagesize();

    duk->stats = newHV();
    duk->msgs = newHV();

    if (opt) {
        hv_iterinit(opt);
        while (1) {
            SV* value = 0;
            I32 klen = 0;
            char* kstr = 0;
            HE* entry = hv_iternext(opt);
            if (!entry) {
                break; /* no more hash keys */
            }
            kstr = hv_iterkey(entry, &klen);
            if (!kstr || klen < 0) {
                continue; /* invalid key */
            }
            value = hv_iterval(opt, entry);
            if (!value) {
                continue; /* invalid value */
            }
            if (memcmp(kstr, DUK_OPT_NAME_GATHER_STATS, klen) == 0) {
                duk->flags |= SvTRUE(value) ? DUK_OPT_FLAG_GATHER_STATS : 0;
                continue;
            }
            if (memcmp(kstr, DUK_OPT_NAME_SAVE_MESSAGES, klen) == 0) {
                duk->flags |= SvTRUE(value) ? DUK_OPT_FLAG_SAVE_MESSAGES : 0;
                continue;
            }
            if (memcmp(kstr, DUK_OPT_NAME_MAX_MEMORY_BYTES, klen) == 0) {
                int param = SvIV(value);
                duk->max_allocated_bytes = param > MAX_MEMORY_MINIMUM ? param : MAX_MEMORY_MINIMUM;
                continue;
            }
            if (memcmp(kstr, DUK_OPT_NAME_MAX_TIMEOUT_US, klen) == 0) {
                int param = SvIV(value);
                duk->max_timeout_us = param > MAX_TIMEOUT_MINIMUM ? param : MAX_TIMEOUT_MINIMUM;
                continue;
            }
            croak("Unknown option %*.*s\n", (int) klen, (int) klen, kstr);
        }
    }

    set_up(duk);
    return duk;
}

static int session_dtor(pTHX_ SV* sv, MAGIC* mg)
{
    Duk* duk = (Duk*) mg->mg_ptr;
    UNUSED_ARG(sv);
    tear_down(duk);
    return 0;
}

static MGVTBL session_magic_vtbl = { .svt_free = session_dtor };

#line 158 "duk.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 302 "duk.c"

XS_EUPXS(XS_JavaScript__Duktape__XS_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "CLASS, opt= NULL");
    {
	Duk *	RETVAL;
	char*	CLASS = (char *)SvPV_nolen(ST(0))
;
	HV*	opt;

	if (items < 2)
	    opt = NULL;
	else {
	    STMT_START {
		    SV* const xsub_tmp_sv = ST(1);
		    SvGETMAGIC(xsub_tmp_sv);
		    if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
			opt = (HV*)SvRV(xsub_tmp_sv);
		    }
		    else{
			Perl_croak_nocontext("%s: %s is not a HASH reference",
				    "JavaScript::Duktape::XS::new",
				    "opt");
		    }
	    } STMT_END
;
	}
#line 156 "duk.xs"
    UNUSED_ARG(opt);
    RETVAL = create_duktape_object(aTHX_ opt);
#line 336 "duk.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pvn(RETVALSV, CLASS, CLASS, strlen(CLASS));
    sv_magicext(SvRV(RETVALSV), SvRV(RETVALSV), PERL_MAGIC_ext, &session_magic_vtbl, (char*) RETVAL, 0);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_JavaScript__Duktape__XS_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "duk");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Duk*	duk;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::reset() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 163 "duk.xs"
    tear_down(duk);
    set_up(duk);
#line 374 "duk.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_JavaScript__Duktape__XS_get_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_get_stats)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "duk");
    {
	HV *	RETVAL;
	Duk*	duk;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::get_stats() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 169 "duk.xs"
    RETVAL = duk->stats;
#line 404 "duk.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_JavaScript__Duktape__XS_reset_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_reset_stats)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "duk");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Duk*	duk;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::reset_stats() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 175 "duk.xs"
    duk->stats = newHV();
#line 440 "duk.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_JavaScript__Duktape__XS_get_msgs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_get_msgs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "duk");
    {
	HV *	RETVAL;
	Duk*	duk;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::get_msgs() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 180 "duk.xs"
    RETVAL = duk->msgs;
#line 470 "duk.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_JavaScript__Duktape__XS_reset_msgs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_reset_msgs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "duk");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Duk*	duk;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::reset_msgs() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 186 "duk.xs"
    duk->msgs = newHV();
#line 506 "duk.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_JavaScript__Duktape__XS_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "duk, name");
    {
#line 191 "duk.xs"
    duk_context* ctx = 0;
    Stats stats;
#line 523 "duk.c"
	SV *	RETVAL;
	Duk*	duk;
	const char*	name = (const char *)SvPV_nolen(ST(1))
;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::get() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 194 "duk.xs"
    TIMEOUT_RESET(duk);
    ctx = duk->ctx;
    pl_stats_start(aTHX_ duk, &stats);
    RETVAL = pl_get_global_or_property(aTHX_ ctx, name);
    pl_stats_stop(aTHX_ duk, &stats, "get");
#line 546 "duk.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_JavaScript__Duktape__XS_exists); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_exists)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "duk, name");
    {
#line 204 "duk.xs"
    duk_context* ctx = 0;
    Stats stats;
#line 564 "duk.c"
	SV *	RETVAL;
	Duk*	duk;
	const char*	name = (const char *)SvPV_nolen(ST(1))
;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::exists() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 207 "duk.xs"
    TIMEOUT_RESET(duk);
    ctx = duk->ctx;
    pl_stats_start(aTHX_ duk, &stats);
    RETVAL = pl_exists_global_or_property(aTHX_ ctx, name);
    pl_stats_stop(aTHX_ duk, &stats, "exists");
#line 587 "duk.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_JavaScript__Duktape__XS_typeof); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_typeof)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "duk, name");
    {
#line 217 "duk.xs"
    duk_context* ctx = 0;
    Stats stats;
#line 605 "duk.c"
	SV *	RETVAL;
	Duk*	duk;
	const char*	name = (const char *)SvPV_nolen(ST(1))
;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::typeof() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 220 "duk.xs"
    TIMEOUT_RESET(duk);
    ctx = duk->ctx;
    pl_stats_start(aTHX_ duk, &stats);
    RETVAL = pl_typeof_global_or_property(aTHX_ ctx, name);
    pl_stats_stop(aTHX_ duk, &stats, "typeof");
#line 628 "duk.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_JavaScript__Duktape__XS_instanceof); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_instanceof)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "duk, object, class");
    {
#line 230 "duk.xs"
    duk_context* ctx = 0;
    Stats stats;
#line 646 "duk.c"
	SV *	RETVAL;
	Duk*	duk;
	const char*	object = (const char *)SvPV_nolen(ST(1))
;
	const char*	class = (const char *)SvPV_nolen(ST(2))
;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::instanceof() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 233 "duk.xs"
    TIMEOUT_RESET(duk);
    ctx = duk->ctx;
    pl_stats_start(aTHX_ duk, &stats);
    RETVAL = pl_instanceof_global_or_property(aTHX_ ctx, object, class);
    pl_stats_stop(aTHX_ duk, &stats, "instanceof");
#line 671 "duk.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_JavaScript__Duktape__XS_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "duk, name, value");
    {
#line 243 "duk.xs"
    duk_context* ctx = 0;
    Stats stats;
#line 689 "duk.c"
	int	RETVAL;
	dXSTARG;
	Duk*	duk;
	const char*	name = (const char *)SvPV_nolen(ST(1))
;
	SV*	value = ST(2)
;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::set() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 246 "duk.xs"
    TIMEOUT_RESET(duk);
    ctx = duk->ctx;
    pl_stats_start(aTHX_ duk, &stats);
    RETVAL = pl_set_global_or_property(aTHX_ ctx, name, value);
    pl_stats_stop(aTHX_ duk, &stats, "set");
#line 715 "duk.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_JavaScript__Duktape__XS_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_remove)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "duk, name");
    {
#line 256 "duk.xs"
    duk_context* ctx = 0;
    Stats stats;
#line 732 "duk.c"
	int	RETVAL;
	dXSTARG;
	Duk*	duk;
	const char*	name = (const char *)SvPV_nolen(ST(1))
;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::remove() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 259 "duk.xs"
    TIMEOUT_RESET(duk);
    ctx = duk->ctx;
    pl_stats_start(aTHX_ duk, &stats);
    RETVAL = pl_del_global_or_property(aTHX_ ctx, name);
    pl_stats_stop(aTHX_ duk, &stats, "remove");
#line 756 "duk.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_JavaScript__Duktape__XS_eval); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_eval)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "duk, js, file= 0");
    {
	SV *	RETVAL;
	Duk*	duk;
	const char*	js = (const char *)SvPV_nolen(ST(1))
;
	const char*	file;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::eval() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;

	if (items < 3)
	    file = 0;
	else {
	    file = (const char *)SvPV_nolen(ST(2))
;
	}
#line 269 "duk.xs"
    TIMEOUT_RESET(duk);
    RETVAL = pl_eval(aTHX_ duk, js, file);
#line 797 "duk.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_JavaScript__Duktape__XS_dispatch_function_in_event_loop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_dispatch_function_in_event_loop)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "duk, func");
    {
#line 276 "duk.xs"
    Stats stats;
#line 814 "duk.c"
	SV *	RETVAL;
	Duk*	duk;
	const char*	func = (const char *)SvPV_nolen(ST(1))
;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::dispatch_function_in_event_loop() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 278 "duk.xs"
    TIMEOUT_RESET(duk);
    pl_stats_start(aTHX_ duk, &stats);
    RETVAL = newSViv(pl_run_function_in_event_loop(duk, func));
    pl_stats_stop(aTHX_ duk, &stats, "dispatch");
#line 836 "duk.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_JavaScript__Duktape__XS_run_gc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_run_gc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "duk");
    {
#line 287 "duk.xs"
    Stats stats;
#line 853 "duk.c"
	SV *	RETVAL;
	Duk*	duk;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::run_gc() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 289 "duk.xs"
    TIMEOUT_RESET(duk);
    pl_stats_start(aTHX_ duk, &stats);
    RETVAL = newSVnv(pl_run_gc(duk));
    pl_stats_stop(aTHX_ duk, &stats, "run_gc");
#line 873 "duk.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_JavaScript__Duktape__XS_global_objects); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_JavaScript__Duktape__XS_global_objects)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "duk");
    {
#line 298 "duk.xs"
    duk_context* ctx = 0;
    Stats stats;
#line 891 "duk.c"
	SV *	RETVAL;
	Duk*	duk;

    {
        MAGIC *mg;
        if (sv_isobject(ST(0)) && SvTYPE(SvRV(ST(0))) == SVt_PVMG &&
            (mg = mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &session_magic_vtbl)) != 0)
        {
            duk = (Duk*) mg->mg_ptr;
        } else {
            croak("JavaScript::Duktape::XS::global_objects() -- duk is not a valid JavaScript::Duktape::XS object");
        }
    }
;
#line 301 "duk.xs"
    TIMEOUT_RESET(duk);
    ctx = duk->ctx;
    pl_stats_start(aTHX_ duk, &stats);
    RETVAL = pl_global_objects(aTHX_ ctx);
    pl_stats_stop(aTHX_ duk, &stats, "global_objects");
#line 912 "duk.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_JavaScript__Duktape__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_JavaScript__Duktape__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("JavaScript::Duktape::XS::new", XS_JavaScript__Duktape__XS_new);
        newXS_deffile("JavaScript::Duktape::XS::reset", XS_JavaScript__Duktape__XS_reset);
        newXS_deffile("JavaScript::Duktape::XS::get_stats", XS_JavaScript__Duktape__XS_get_stats);
        newXS_deffile("JavaScript::Duktape::XS::reset_stats", XS_JavaScript__Duktape__XS_reset_stats);
        newXS_deffile("JavaScript::Duktape::XS::get_msgs", XS_JavaScript__Duktape__XS_get_msgs);
        newXS_deffile("JavaScript::Duktape::XS::reset_msgs", XS_JavaScript__Duktape__XS_reset_msgs);
        newXS_deffile("JavaScript::Duktape::XS::get", XS_JavaScript__Duktape__XS_get);
        newXS_deffile("JavaScript::Duktape::XS::exists", XS_JavaScript__Duktape__XS_exists);
        newXS_deffile("JavaScript::Duktape::XS::typeof", XS_JavaScript__Duktape__XS_typeof);
        newXS_deffile("JavaScript::Duktape::XS::instanceof", XS_JavaScript__Duktape__XS_instanceof);
        newXS_deffile("JavaScript::Duktape::XS::set", XS_JavaScript__Duktape__XS_set);
        newXS_deffile("JavaScript::Duktape::XS::remove", XS_JavaScript__Duktape__XS_remove);
        newXS_deffile("JavaScript::Duktape::XS::eval", XS_JavaScript__Duktape__XS_eval);
        newXS_deffile("JavaScript::Duktape::XS::dispatch_function_in_event_loop", XS_JavaScript__Duktape__XS_dispatch_function_in_event_loop);
        newXS_deffile("JavaScript::Duktape::XS::run_gc", XS_JavaScript__Duktape__XS_run_gc);
        newXS_deffile("JavaScript::Duktape::XS::global_objects", XS_JavaScript__Duktape__XS_global_objects);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

